Index: issm/trunk/src/c/matlab/io/MatlabVectorToSeqVec.cpp
===================================================================
--- issm/trunk/src/c/matlab/io/MatlabVectorToSeqVec.cpp	(revision 12709)
+++ issm/trunk/src/c/matlab/io/MatlabVectorToSeqVec.cpp	(revision 13395)
@@ -19,9 +19,9 @@
 /*}}}*/
 
-SeqVec* MatlabVectorToSeqVec(const mxArray* dataref){
+SeqVec<double>* MatlabVectorToSeqVec(const mxArray* dataref){
 
-	SeqVec* output=NULL;
+	SeqVec<double>* output=NULL;
 
-	output=new SeqVec();
+	output=new SeqVec<double>();
 	MatlabVectorToDoubleVector(&output->vector,&output->M,dataref);
 	return output;
Index: issm/trunk/src/c/matlab/io/MatlabVectorToVector.cpp
===================================================================
--- issm/trunk/src/c/matlab/io/MatlabVectorToVector.cpp	(revision 12709)
+++ issm/trunk/src/c/matlab/io/MatlabVectorToVector.cpp	(revision 13395)
@@ -14,5 +14,5 @@
 #include <string.h>
 #include "./matlabio.h"
-#include "../../objects/objects.h"
+#include "../../classes/classes.h"
 #include "../../shared/shared.h"
 #include "../../Container/Container.h"
@@ -22,16 +22,16 @@
 /*}}}*/
 
-Vector* MatlabVectorToVector(const mxArray* mxvector){
+Vector<double>* MatlabVectorToVector(const mxArray* mxvector){
 
 	int dummy;
-	Vector* vector=NULL;
+	Vector<double>* vector=NULL;
 
 	/*allocate vector object: */
-	vector=new Vector();
+	vector=new Vector<double>();
 
 	#ifdef _HAVE_PETSC_
-	MatlabVectorToPetscVector(&vector->vector,&dummy,mxvector);
+	vector->pvector=MatlabVectorToPetscVec(mxvector);
 	#else
-	vector->vector=MatlabVectorToSeqVec(mxvector);
+	vector->svector=MatlabVectorToSeqVec(mxvector);
 	#endif
 	
Index: issm/trunk/src/c/matlab/io/OptionParse.cpp
===================================================================
--- issm/trunk/src/c/matlab/io/OptionParse.cpp	(revision 12709)
+++ issm/trunk/src/c/matlab/io/OptionParse.cpp	(revision 13395)
@@ -15,29 +15,42 @@
 #include "./matlabio.h"
 
-/*FUNCTION OptionDoubleParse {{{*/
-OptionDouble* OptionDoubleParse( char* name, const mxArray* prhs[]){
-
-	OptionDouble *odouble = NULL;
-
-	/*check and parse the name  */
-	odouble=new OptionDouble;
+GenericOption<double>* OptionDoubleParse( char* name, const mxArray* prhs[]){ /*{{{*/
+
+	GenericOption<double> *odouble = NULL;
+
+	/*check and parse the name  */
+	odouble=new GenericOption<double>();
 	odouble->name =xNew<char>(strlen(name)+1);
 	memcpy(odouble->name,name,(strlen(name)+1)*sizeof(char));
+	FetchData(&odouble->value,prhs[0]);
+	odouble->numel=1;
+	odouble->ndims=1;
+	odouble->size=NULL;
+
+	return(odouble);
+}/*}}}*/
+GenericOption<double*>* OptionDoubleArrayParse( char* name, const mxArray* prhs[]){ /*{{{*/
+
+	GenericOption<double*> *odouble = NULL;
+
+	/*check and parse the name  */
+	odouble=new GenericOption<double*>();
+	odouble->name =xNew<char>(strlen(name)+1);
+	memcpy(odouble->name,name,(strlen(name)+1)*sizeof(char));
 
 	/*check and parse the value  */
 	if (!mxIsClass(prhs[0],"double")){
-		_error2_("Value of option \"" << odouble->name  << "\" must be class \"double\", not class \"" << mxGetClassName(prhs[0]) <<"\".");
-	}
-	FetchData(&odouble->values,&odouble->numel,&odouble->ndims,&odouble->size,prhs[0]);
+		_error_("Value of option \"" << odouble->name  << "\" must be class \"double\", not class \"" << mxGetClassName(prhs[0]) <<"\".");
+	}
+	FetchData(&odouble->value,&odouble->numel,&odouble->ndims,&odouble->size,prhs[0]);
 
 	return(odouble);
 }/*}}}*/
-/*FUNCTION OptionLogicalParse {{{*/
-OptionLogical* OptionLogicalParse( char* name, const mxArray* prhs[]){
-
-	OptionLogical *ological = NULL;
-
-	/*check and parse the name  */
-	ological=new OptionLogical;
+GenericOption<bool*>* OptionLogicalParse( char* name, const mxArray* prhs[]){ /*{{{*/
+
+	GenericOption<bool*> *ological = NULL;
+
+	/*check and parse the name  */
+	ological=new GenericOption<bool*>();
 	ological->name =xNew<char>(strlen(name)+1);
 	memcpy(ological->name,name,(strlen(name)+1)*sizeof(char));
@@ -45,17 +58,16 @@
 	/*check and parse the value  */
 	if (!mxIsClass(prhs[0],"logical")){
-		_error2_("Value of option \"" << ological->name  << "\" must be class \"logical\", not class \"" << mxGetClassName(prhs[0]) <<"\".");
-	}
-	FetchData(&ological->values,&ological->numel,&ological->ndims,&ological->size,prhs[0]);
+		_error_("Value of option \"" << ological->name  << "\" must be class \"logical\", not class \"" << mxGetClassName(prhs[0]) <<"\".");
+	}
+	FetchData(&ological->value,&ological->numel,&ological->ndims,&ological->size,prhs[0]);
 
 	return(ological);
 }/*}}}*/
-/*FUNCTION OptionCharParse {{{*/
-OptionChar* OptionCharParse( char* name, const mxArray* prhs[]){
-
-	OptionChar  *ochar = NULL;
-
-	/*check and parse the name  */
-	ochar=new OptionChar();
+GenericOption<char*>* OptionCharParse( char* name, const mxArray* prhs[]){ /*{{{*/
+
+	GenericOption<char*>  *ochar = NULL;
+
+	/*check and parse the name  */
+	ochar=new GenericOption<char*>();
 	ochar->name =xNew<char>(strlen(name)+1);
 	memcpy(ochar->name,name,(strlen(name)+1)*sizeof(char));
@@ -63,17 +75,16 @@
 	/*check and parse the value  */
 	if (!mxIsClass(prhs[0],"char")){
-		_error2_("Value of option \"" << ochar->name  << "\" must be class \"char\", not class \"" << mxGetClassName(prhs[0]) <<"\".");
-	}
-	FetchData(&ochar->values,&ochar->numel,&ochar->ndims,&ochar->size,prhs[0]);
+		_error_("Value of option \"" << ochar->name  << "\" must be class \"char\", not class \"" << mxGetClassName(prhs[0]) <<"\".");
+	}
+	FetchData(&ochar->value,&ochar->numel,&ochar->ndims,&ochar->size,prhs[0]);
 
 	return(ochar);
 }/*}}}*/
-/*FUNCTION OptionStructParse {{{*/
-OptionStruct* OptionStructParse( char* name, const mxArray* prhs[]){
+GenericOption<Options**>* OptionStructParse( char* name, const mxArray* prhs[]){ /*{{{*/
 
 	int            i;
 	char           namei[161];
-	OptionStruct  *ostruct    = NULL;
-	Option        *option     = NULL;
+	Option*                   option      = NULL;
+	GenericOption<Options**>  *ostruct    = NULL;
 	const mwSize  *ipt        = NULL;
 	const mxArray *structi;
@@ -81,5 +92,5 @@
 
 	/*check and parse the name  */
-	ostruct=new OptionStruct;
+	ostruct=new GenericOption<Options**>();
 	ostruct->name =xNew<char>(strlen(name)+1);
 	memcpy(ostruct->name,name,(strlen(name)+1)*sizeof(char));
@@ -87,5 +98,5 @@
 	/*check and parse the value  */
 	if (!mxIsClass(prhs[0],"struct")){
-		_error2_("Value of option \"" << ostruct->name  << "\" must be class \"struct\", not class \"" << mxGetClassName(prhs[0]) <<"\".");
+		_error_("Value of option \"" << ostruct->name  << "\" must be class \"struct\", not class \"" << mxGetClassName(prhs[0]) <<"\".");
 	}
 	ostruct->numel=mxGetNumberOfElements(prhs[0]);
@@ -94,9 +105,9 @@
 	ostruct->size =xNew<int>(ostruct->ndims);
 	for (i=0; i<ostruct->ndims; i++) ostruct->size[i]=(int)ipt[i];
-	if (ostruct->numel) ostruct->values=xNew<Options*>(ostruct->numel);
+	if (ostruct->numel) ostruct->value=xNew<Options*>(ostruct->numel);
 
 	/*loop through and process each element of the struct array  */
 	for (sindex=0; sindex<ostruct->numel; sindex++) {
-		ostruct->values[sindex]=new Options;
+		ostruct->value[sindex]=new Options;
 
 		/*loop through and process each field for the element  */
@@ -106,5 +117,5 @@
 
 			option=(Option*)OptionParse(namei,&structi);
-			ostruct->values[sindex]->AddObject((Object*)option);
+			ostruct->value[sindex]->AddObject((Object*)option);
 			option=NULL;
 		}
@@ -113,6 +124,5 @@
 	return(ostruct);
 }/*}}}*/
-/*FUNCTION OptionCellParse {{{*/
-OptionCell* OptionCellParse( char* name, const mxArray* prhs[]){
+GenericOption<Options*>* OptionCellParse( char* name, const mxArray* prhs[]){ /*{{{*/
 
 	int            i;
@@ -120,5 +130,5 @@
 	char           namei[161];
 	char           cstr[81];
-	OptionCell    *ocell      = NULL;
+	GenericOption<Options*> *ocell      = NULL;
 	Option        *option     = NULL;
 	const mwSize  *ipt        = NULL;
@@ -127,5 +137,5 @@
 
 	/*check and parse the name  */
-	ocell=new OptionCell;
+	ocell=new GenericOption<Options*>();
 	ocell->name =xNew<char>(strlen(name)+1);
 	memcpy(ocell->name,name,(strlen(name)+1)*sizeof(char));
@@ -133,5 +143,5 @@
 	/*check and parse the value  */
 	if (!mxIsClass(prhs[0],"cell")){
-		_error2_("Value of option \"" << ocell->name  << "\" must be class \"cell\", not class \"" << mxGetClassName(prhs[0]) <<"\".");
+		_error_("Value of option \"" << ocell->name  << "\" must be class \"cell\", not class \"" << mxGetClassName(prhs[0]) <<"\".");
 	}
 
@@ -141,5 +151,5 @@
 	ocell->size =xNew<int>(ocell->ndims);
 	for (i=0; i<ocell->ndims; i++) ocell->size[i]=(int)ipt[i];
-	ocell->values=new Options;
+	ocell->value=new Options;
 
 	/*loop through and process each element of the cell array  */
@@ -156,5 +166,5 @@
 
 		option=(Option*)OptionParse(namei,&celli);
-		ocell->values->AddObject((Object*)option);
+		ocell->value->AddObject((Object*)option);
 		option=NULL;
 	}
@@ -163,16 +173,22 @@
 	return(ocell);
 }/*}}}*/
-/*FUNCTION OptionParse{{{*/
-Option* OptionParse(char* name, const mxArray* prhs[]){
-
-	Option *option = NULL;
-	mxArray       *lhs[1];
+Option* OptionParse(char* name, const mxArray* prhs[]){ /*{{{*/
+
+	Option  *option = NULL;
+	mxArray *lhs[1];
 
 	/*parse the value according to the matlab data type  */
-	if     (mxIsClass(prhs[0],"double"))  option=(Option*)OptionDoubleParse(name,prhs);
-	else if(mxIsClass(prhs[0],"logical")) option=(Option*)OptionLogicalParse(name,prhs);
-	else if(mxIsClass(prhs[0],"char"))    option=(Option*)OptionCharParse(name,prhs);
-	else if(mxIsClass(prhs[0],"struct"))  option=(Option*)OptionStructParse(name,prhs);
-	else if(mxIsClass(prhs[0],"cell"))    option=(Option*)OptionCellParse(name,prhs);
+	if     (mxIsClass(prhs[0],"double")  && (mxGetNumberOfElements(prhs[0])==1))
+	 option=(Option*)OptionDoubleParse(name,prhs);
+	else if(mxIsClass(prhs[0],"double")  && (mxGetNumberOfElements(prhs[0])!=1))
+	 option=(Option*)OptionDoubleArrayParse(name,prhs);
+	else if(mxIsClass(prhs[0],"logical"))
+	 option=(Option*)OptionLogicalParse(name,prhs);
+	else if(mxIsClass(prhs[0],"char"))
+	 option=(Option*)OptionCharParse(name,prhs);
+	else if(mxIsClass(prhs[0],"struct"))
+	 option=(Option*)OptionStructParse(name,prhs);
+	else if(mxIsClass(prhs[0],"cell"))
+	 option=(Option*)OptionCellParse(name,prhs);
 	else {
 		_pprintLine_("  Converting value of option \"" << name << "\" from unrecognized class \"" << mxGetClassName(prhs[0]) << "\" to class \"" << "struct" << "\".");
@@ -181,5 +197,5 @@
 			mxDestroyArray(lhs[0]);
 		}
-		else _error2_("Second argument value of option \""<< name <<"\" is of unrecognized class \""<< mxGetClassName(prhs[0]) <<"\".");
+		else _error_("Second argument value of option \""<< name <<"\" is of unrecognized class \""<< mxGetClassName(prhs[0]) <<"\".");
 	}
 
Index: issm/trunk/src/c/matlab/io/WriteMatlabData.cpp
===================================================================
--- issm/trunk/src/c/matlab/io/WriteMatlabData.cpp	(revision 12709)
+++ issm/trunk/src/c/matlab/io/WriteMatlabData.cpp	(revision 13395)
@@ -9,10 +9,8 @@
 #endif
 
+#include <mex.h>
 #include "../../include/include.h"
 #include "../../shared/shared.h"
 #include "./matlabio.h"
-
-#include <mex.h>
-
 
 /*Primitive data types*/
@@ -124,5 +122,5 @@
 	int         i;
 	mxArray    *dataref           = NULL;
-	const int   numfields         = 7;
+	const int   numfields         = 8;
 	const char *fnames[numfields];
 	mwSize      ndim              = 2;
@@ -134,4 +132,5 @@
 	fnames[i++] = "Edges";
 	fnames[i++] = "TangentAtEdges";
+	fnames[i++] = "Corners";
 	fnames[i++] = "RequiredVertices";
 	fnames[i++] = "RequiredEdges";
@@ -148,4 +147,5 @@
 	i++; SetStructureField(dataref,"Edges",           bamggeom->EdgesSize[0],           bamggeom->EdgesSize[1],           bamggeom->Edges);
 	i++; SetStructureField(dataref,"TangentAtEdges",  bamggeom->TangentAtEdgesSize[0],  bamggeom->TangentAtEdgesSize[1],  bamggeom->TangentAtEdges);
+	i++; SetStructureField(dataref,"Corners",         bamggeom->CornersSize[0],         bamggeom->CornersSize[1],         bamggeom->Corners);
 	i++; SetStructureField(dataref,"RequiredVertices",bamggeom->RequiredVerticesSize[0],bamggeom->RequiredVerticesSize[1],bamggeom->RequiredVertices);
 	i++; SetStructureField(dataref,"RequiredEdges",   bamggeom->RequiredEdgesSize[0],   bamggeom->RequiredEdgesSize[1],   bamggeom->RequiredEdges);
@@ -171,10 +171,10 @@
 	/*Initialize field names*/
 	i=0;
-	fnames[i++] = "Triangles";
 	fnames[i++] = "Vertices";
 	fnames[i++] = "Edges";
+	fnames[i++] = "Triangles";
+	fnames[i++] = "Quadrilaterals";
+	fnames[i++] = "IssmEdges";
 	fnames[i++] = "IssmSegments";
-	fnames[i++] = "IssmEdges";
-	fnames[i++] = "Quadrilaterals";
 	fnames[i++] = "VerticesOnGeomVertex";
 	fnames[i++] = "VerticesOnGeomEdge";
@@ -194,10 +194,10 @@
 	/*set each matlab each field*/
 	i=0;
-	i++; SetStructureField(dataref,"Triangles", bamgmesh->TrianglesSize[0],bamgmesh->TrianglesSize[1], bamgmesh->Triangles);
 	i++; SetStructureField(dataref,"Vertices",bamgmesh->VerticesSize[0], bamgmesh->VerticesSize[1],bamgmesh->Vertices);
 	i++; SetStructureField(dataref,"Edges", bamgmesh->EdgesSize[0],bamgmesh->EdgesSize[1], bamgmesh->Edges);
+	i++; SetStructureField(dataref,"Triangles", bamgmesh->TrianglesSize[0],bamgmesh->TrianglesSize[1], bamgmesh->Triangles);
+	i++; SetStructureField(dataref,"Quadrilaterals",bamgmesh->QuadrilateralsSize[0], bamgmesh->QuadrilateralsSize[1],bamgmesh->Quadrilaterals);
+	i++; SetStructureField(dataref,"IssmEdges", bamgmesh->IssmEdgesSize[0],bamgmesh->IssmEdgesSize[1], bamgmesh->IssmEdges);
 	i++; SetStructureField(dataref,"IssmSegments",bamgmesh->IssmSegmentsSize[0], bamgmesh->IssmSegmentsSize[1],bamgmesh->IssmSegments);
-	i++; SetStructureField(dataref,"IssmEdges", bamgmesh->IssmEdgesSize[0],bamgmesh->IssmEdgesSize[1], bamgmesh->IssmEdges);
-	i++; SetStructureField(dataref,"Quadrilaterals",bamgmesh->QuadrilateralsSize[0], bamgmesh->QuadrilateralsSize[1],bamgmesh->Quadrilaterals);
 	i++; SetStructureField(dataref,"VerticesOnGeomVertex",bamgmesh->VerticesOnGeomVertexSize[0],bamgmesh->VerticesOnGeomVertexSize[1], bamgmesh->VerticesOnGeomVertex);
 	i++; SetStructureField(dataref,"VerticesOnGeomEdge",bamgmesh->VerticesOnGeomEdgeSize[0],bamgmesh->VerticesOnGeomEdgeSize[1], bamgmesh->VerticesOnGeomEdge);
@@ -216,6 +216,6 @@
 }
 /*}}}*/
-/*FUNCTION WriteData(mxArray** pdataref,Matrix* matrix){{{*/
-void WriteData(mxArray** pdataref,Matrix* matrix){
+/*FUNCTION WriteData(mxArray** pdataref,SeqMat<double>* matrix){{{*/
+void WriteData(mxArray** pdataref,SeqMat<double>* matrix){
 		
 	int      i,j;
@@ -227,10 +227,6 @@
 	if(matrix){
 		
-		#ifdef _HAVE_PETSC_
-		PetscMatrixToDoubleMatrix(&matrix_ptr,&rows,&cols,matrix->matrix);
-		#else
-		matrix_ptr=matrix->matrix->ToSerial();
-		matrix->matrix->GetSize(&rows,&cols);
-		#endif
+		matrix_ptr=matrix->ToSerial();
+		matrix->GetSize(&rows,&cols);
 
 		/*Now transpose the matrix and allocate with Matlab's memory manager: */
@@ -250,15 +246,14 @@
 		/*Free ressources:*/
 		xDelete<double>(matrix_ptr);
-
-	}
-	else{
-		dataref = mxCreateDoubleMatrix(0,0,mxREAL);
-	}
-
-	*pdataref=dataref;
-}
-/*}}}*/
-/*FUNCTION WriteData(mxArray** pdataref,Vector* vector){{{*/
-void WriteData(mxArray** pdataref,Vector* vector){
+	}
+	else{
+		dataref = mxCreateDoubleMatrix(0,0,mxREAL);
+	}
+
+	*pdataref=dataref;
+}
+/*}}}*/
+/*FUNCTION WriteData(mxArray** pdataref,SeqVec<double>* vector){{{*/
+void WriteData(mxArray** pdataref,SeqVec<double>* vector){
 	
 	mxArray* dataref=NULL;
@@ -269,10 +264,6 @@
 	if(vector){
 		/*call toolkit routine: */
-		#ifdef _HAVE_PETSC_
-		PetscVectorToDoubleVector(&vector_ptr,&rows,vector->vector);
-		#else
-		vector_ptr=vector->vector->ToMPISerial();
-		vector->vector->GetSize(&rows);
-		#endif
+		vector_ptr=vector->ToMPISerial();
+		vector->GetSize(&rows);
 		
 		/*now create the matlab vector with Matlab's memory manager */
Index: issm/trunk/src/c/matlab/io/matlabio.h
===================================================================
--- issm/trunk/src/c/matlab/io/matlabio.h	(revision 12709)
+++ issm/trunk/src/c/matlab/io/matlabio.h	(revision 13395)
@@ -12,14 +12,13 @@
 #endif 
 
-#include "../../objects/objects.h"
+#include <mex.h>
+#include "../../classes/classes.h"
 #include "../../Container/Container.h"
 #include "../../include/include.h"
 
-#include <mex.h>
-
-void WriteData(mxArray** pdataref,Matrix* matrix);
+void WriteData(mxArray** pdataref,SeqMat<double>* matrix);
 void WriteData(mxArray** pdataref,double* matrix, int M,int N);
 void WriteData(mxArray** pdataref,int*    matrix, int M,int N);
-void WriteData(mxArray** pdataref,Vector* vector);
+void WriteData(mxArray** pdataref,SeqVec<double>* vector);
 void WriteData(mxArray** pdataref,double* vector, int M);
 void WriteData(mxArray** pdataref,int integer);
@@ -35,10 +34,10 @@
 void FetchData(bool** pmatrix,int* pM,int *pN,const mxArray* dataref);
 void FetchData(bool** pmatrix,int* pnumel,int* pndims,int** psize,const mxArray* dataref);
-void FetchData(Matrix** pmatrix,const mxArray* dataref);
+void FetchData(Matrix<double>** pmatrix,const mxArray* dataref);
 void FetchData(int** pvector,int* pM,const mxArray* dataref);
 void FetchData(float** pvector,int* pM,const mxArray* dataref);
 void FetchData(double** pvector,int* pM,const mxArray* dataref);
 void FetchData(bool** pvector,int* pM,const mxArray* dataref);
-void FetchData(Vector** pvector,const mxArray* dataref);
+void FetchData(Vector<double>** pvector,const mxArray* dataref);
 void FetchData(char** pstring,const mxArray* dataref);
 void FetchData(char** pmatrix,int* pnumel,int* pndims,int** psize,const mxArray* dataref);
@@ -50,11 +49,13 @@
 void FetchData(BamgOpts** bamgopts,const mxArray* dataref);
 void FetchData(Options** poptions,int istart, int nrhs,const mxArray** pdataref);
+void FetchData(DataSet** pcontours,const mxArray* dataref);
 
 Option* OptionParse(char* name, const mxArray* prhs[]);
-OptionDouble*   OptionDoubleParse( char* name, const mxArray* prhs[]);
-OptionLogical*  OptionLogicalParse( char* name, const mxArray* prhs[]);
-OptionChar*     OptionCharParse( char* name, const mxArray* prhs[]);
-OptionStruct*   OptionStructParse( char* name, const mxArray* prhs[]);
-OptionCell*     OptionCellParse( char* name, const mxArray* prhs[]);
+GenericOption<double>*    OptionDoubleParse( char* name, const mxArray* prhs[]);
+GenericOption<double*>*   OptionDoubleArrayParse( char* name, const mxArray* prhs[]);
+GenericOption<bool*>*     OptionLogicalParse( char* name, const mxArray* prhs[]);
+GenericOption<char*>*     OptionCharParse( char* name, const mxArray* prhs[]);
+GenericOption<Options**>* OptionStructParse( char* name, const mxArray* prhs[]);
+GenericOption<Options*>*  OptionCellParse( char* name, const mxArray* prhs[]);
 
 mxArray* mxGetAssignedField(const mxArray* pmxa_array,int number, const char* field);
@@ -63,6 +64,6 @@
 
 /*Matlab to Matrix routines: */
-Matrix* MatlabMatrixToMatrix(const mxArray* mxmatrix);
-Vector* MatlabVectorToVector(const mxArray* mxvector);
+Matrix<double>* MatlabMatrixToMatrix(const mxArray* mxmatrix);
+Vector<double>* MatlabVectorToVector(const mxArray* mxvector);
 
 /*Matlab to double* routines: */
@@ -74,13 +75,14 @@
 
 /*Matlab to SeqMat routines: */
-SeqMat* MatlabMatrixToSeqMat(const mxArray* dataref);
-SeqVec* MatlabVectorToSeqVec(const mxArray* dataref);
+SeqMat<double>* MatlabMatrixToSeqMat(const mxArray* dataref);
+SeqVec<double>* MatlabVectorToSeqVec(const mxArray* dataref);
 
 /*Matlab to Petsc routines: */
 #ifdef _HAVE_PETSC_
-int MatlabMatrixToPetscMatrix(Mat* matrix,int* prows,int* pcols, const mxArray* mxmatrix);
-int MatlabVectorToPetscVector(Vec* pvector,int* pvector_rows,const mxArray* mxvector);
+int MatlabMatrixToPetscMat(Mat* matrix,int* prows,int* pcols, const mxArray* mxmatrix);
+PetscMat* MatlabMatrixToPetscMat(const mxArray* mxmatrix);
+int MatlabVectorToPetscVec(Vec* pvector,int* pvector_rows,const mxArray* mxvector);
+PetscVec* MatlabVectorToPetscVec(const mxArray* mxvector);
 #endif
 
-
 #endif	/* _IO_H_ */
Index: issm/trunk/src/c/modules/AddExternalResultx/AddExternalResultx.cpp
===================================================================
--- issm/trunk/src/c/modules/AddExternalResultx/AddExternalResultx.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/AddExternalResultx/AddExternalResultx.cpp	(revision 13395)
@@ -7,12 +7,19 @@
 #include "../../Container/Container.h"
 #include "../../io/io.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 		
-void AddExternalResultx( DataSet* results, int enumtype, double value){
+void AddExternalResultx( DataSet* results, int enumtype, IssmDouble value){
 	/* Add new result in into results*/
-	results->AddObject(new DoubleExternalResult(results->Size()+1,enumtype,value,1,0));
+	results->AddObject(new GenericExternalResult<double>(results->Size()+1,enumtype,reCast<IssmPDouble>(value),1,0));
 }
-void AddExternalResultx( DataSet* results, int enumtype, double* value, int nraws){
+void AddExternalResultx( DataSet* results, int enumtype, IssmDouble* value, int nrows){
 	/* Add new result in into results*/
-	results->AddObject(new DoubleVecExternalResult(results->Size()+1,enumtype,value,nraws,1,0));
+	#ifdef _HAVE_ADOLC_
+	IssmPDouble* value_passive=xNew<IssmPDouble>(nrows);
+	for(int i=0;i<nrows;i++)value_passive[i]=reCast<IssmPDouble>(value[i]);
+	results->AddObject(new GenericExternalResult<double*>(results->Size()+1,enumtype,value_passive,nrows,1,1,0));
+	xDelete<IssmPDouble>(value_passive);
+	#else
+	results->AddObject(new GenericExternalResult<double*>(results->Size()+1,enumtype,value,nrows,1,1,0));
+	#endif
 }
Index: issm/trunk/src/c/modules/AddExternalResultx/AddExternalResultx.h
===================================================================
--- issm/trunk/src/c/modules/AddExternalResultx/AddExternalResultx.h	(revision 12709)
+++ issm/trunk/src/c/modules/AddExternalResultx/AddExternalResultx.h	(revision 13395)
@@ -9,6 +9,6 @@
 
 /* local prototypes: */
-void AddExternalResultx(DataSet* results, int type, double value);
-void AddExternalResultx(DataSet* results, int type, double* value, int nraws);
+void AddExternalResultx(DataSet* results, int type, IssmDouble value);
+void AddExternalResultx(DataSet* results, int type, IssmDouble* value, int nraws);
 
 #endif  /* _ADDEXTERNALRESULT_H */
Index: issm/trunk/src/c/modules/AutodiffDriversx/AutodiffDriversx.cpp
===================================================================
--- issm/trunk/src/c/modules/AutodiffDriversx/AutodiffDriversx.cpp	(revision 13395)
+++ issm/trunk/src/c/modules/AutodiffDriversx/AutodiffDriversx.cpp	(revision 13395)
@@ -0,0 +1,96 @@
+/*!\file AutodiffDriversx
+ * \brief: compute outputs from the AD mode,  using our dependents and independents, and drivers available in Adolc.
+ */
+
+#include "../../modules/modules.h"
+#include "../../shared/shared.h"
+#include "../../include/include.h"
+#include "../../toolkits/toolkits.h"
+#include "../../EnumDefinitions/EnumDefinitions.h"
+#include "../../shared/Numerics/adolc_edf.h"
+
+
+void AutodiffDriversx(Elements* elements,Nodes* nodes,Vertices* vertices,Loads* loads,Materials* materials,Parameters* parameters,Results* results){
+	bool isautodiff       = false;
+	/*AD mode on?: */
+	parameters->FindParam(&isautodiff,AutodiffIsautodiffEnum);
+	if(isautodiff){
+		#ifdef _HAVE_ADOLC_
+			int  num_dependents;
+			parameters->FindParam(&num_dependents,AutodiffNumDependentsEnum);
+			int  num_independents;
+			parameters->FindParam(&num_independents,AutodiffNumIndependentsEnum);
+			if(!(num_dependents*num_independents)) return;
+			int  numberofvertices;
+			parameters->FindParam(&numberofvertices,MeshNumberofverticesEnum);
+			/*retrieve state variable: */
+			IssmDouble  *axp  = NULL;
+			parameters->FindParam(&axp,&num_independents,AutodiffXpEnum);
+			/* driver argument */
+			double *xp=xNew<double>(num_independents);
+			for(int i=0;i<num_independents;i++){
+				xp[i]=reCast<double,IssmDouble>(axp[i]);
+			}
+			/* get the dimension for the solverx arguments*/
+			int configuration_type;
+			parameters->FindParam(&configuration_type,ConfigurationTypeEnum);
+			int solveSize=nodes->NumberOfDofs(configuration_type,FsetEnum);
+			int edf_n=solveSize*(solveSize+1), edf_m=solveSize;
+
+			/*get the EDF pointer:*/
+			ext_diff_fct *anEDF_for_solverx_p=dynamic_cast<GenericParam<Adolc_edf> * >(parameters->FindParamObject(AdolcParamEnum))->GetParameterValue().myEDF_for_solverx_p;
+
+			/*set the forward method function pointers: */
+			anEDF_for_solverx_p->zos_forward=EDF_for_solverx;
+			anEDF_for_solverx_p->fos_forward=EDF_fos_forward_for_solverx;
+			anEDF_for_solverx_p->fov_forward=EDF_fov_forward_for_solverx;
+			anEDF_for_solverx_p->fos_reverse=EDF_fos_reverse_for_solverx;
+			// anEDF_for_solverx_p->fov_reverse=EDF_fov_reverse_for_solverx;
+			/*allocate the space for the parameters to invoke the forward methods:*/
+			anEDF_for_solverx_p->dp_x=xNew<double>(edf_n);
+			anEDF_for_solverx_p->dp_X=xNew<double>(edf_n);
+			anEDF_for_solverx_p->dpp_X=xNew<double>(edf_n, num_independents);
+			anEDF_for_solverx_p->dp_y=xNew<double>(edf_m);
+			anEDF_for_solverx_p->dp_Y=xNew<double>(edf_m);
+			anEDF_for_solverx_p->dpp_Y=xNew<double>(edf_m, num_independents);
+			anEDF_for_solverx_p->dp_U=xNew<double>(edf_m);
+			anEDF_for_solverx_p->dpp_U=xNew<double>(num_dependents,edf_m);
+			anEDF_for_solverx_p->dp_Z=xNew<double>(edf_n);
+			anEDF_for_solverx_p->dpp_Z=xNew<double>(num_dependents,edf_n);
+			/* Call AD driver:*/
+			// single direction:
+			double *tangentDir=xNewZeroInit<double>(num_independents);
+			unsigned int anIndepNum=55; // <---------- make this selectable via config
+			tangentDir[anIndepNum]=1.0;
+			double *theJacVecProduct=xNew<double>(num_dependents);
+			double *theOutput=xNew<double>(num_dependents);
+			if (fos_forward(1,num_dependents,num_independents, 0, xp, tangentDir, theOutput, theJacVecProduct ))
+				_error_("fos_forward returned non-zero error code");
+			results->AddObject(new GenericExternalResult<IssmPDouble*>(results->Size()+1,AutodiffJacobianEnum,theJacVecProduct,num_dependents,1,1,0.0));
+
+#if 0
+			double **J=xNew<double>(num_dependents,num_independents);
+			jacobian(1,num_dependents,num_independents,xp,J);
+			results->AddObject(new GenericExternalResult<IssmPDouble*>(results->Size()+1,AutodiffJacobianEnum,*J,num_independents,num_dependents,1,1,0.0));
+			xDelete(J);
+#endif
+
+			/* delete the allocated space for the parameters:*/
+			xDelete(anEDF_for_solverx_p->dp_x);
+			xDelete(anEDF_for_solverx_p->dp_X);
+			xDelete(anEDF_for_solverx_p->dpp_X);
+			xDelete(anEDF_for_solverx_p->dp_y);
+			xDelete(anEDF_for_solverx_p->dp_Y);
+			xDelete(anEDF_for_solverx_p->dpp_Y);
+			xDelete(anEDF_for_solverx_p->dp_U);
+			xDelete(anEDF_for_solverx_p->dpp_U);
+			xDelete(anEDF_for_solverx_p->dp_Z);
+			xDelete(anEDF_for_solverx_p->dpp_Z);
+			/*Free ressources: */
+			xDelete(xp);
+			xDelete(axp); // did we allocate this?
+		#else
+			_error_("Should not be requesting AD drivers when an AD library is not available!");
+		#endif
+	}
+}
Index: issm/trunk/src/c/modules/AutodiffDriversx/AutodiffDriversx.h
===================================================================
--- issm/trunk/src/c/modules/AutodiffDriversx/AutodiffDriversx.h	(revision 13395)
+++ issm/trunk/src/c/modules/AutodiffDriversx/AutodiffDriversx.h	(revision 13395)
@@ -0,0 +1,13 @@
+/*!\file:  AutodiffDriversx.h
+ * \brief header file for  requesting AD results (gradient, jacobian, etc ...)
+ */ 
+
+#ifndef _AUTODIFF_DRIVERSX_H_
+#define _AUTODIFF_DRIVERSX_H_
+
+#include "../../Container/Container.h"
+
+/* local prototypes: */
+void AutodiffDriversx(Elements* elements,Nodes* nodes,Vertices* vertices,Loads* loads,Materials* materials,Parameters* parameters,Results* results);
+
+#endif  /* _AUTODIFF_DRIVERSX_H_*/
Index: issm/trunk/src/c/modules/AverageOntoPartitionx/AverageOntoPartitionx.cpp
===================================================================
--- issm/trunk/src/c/modules/AverageOntoPartitionx/AverageOntoPartitionx.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/AverageOntoPartitionx/AverageOntoPartitionx.cpp	(revision 13395)
@@ -29,7 +29,7 @@
 
 	/*output: */
-	Vector* partition_contributions=NULL;
-	Vector* partition_areas=NULL;
-	Vector* vec_average=NULL;
+	Vector<IssmDouble>* partition_contributions=NULL;
+	Vector<IssmDouble>* partition_areas=NULL;
+	Vector<IssmDouble>* vec_average=NULL;
 	double* average=NULL;
 
@@ -44,7 +44,7 @@
 
 	/*allocate: */
-	partition_contributions=new Vector(npart);
-	partition_areas=new Vector(npart);
-	vec_average=new Vector(npart);
+	partition_contributions=new Vector<IssmDouble>(npart);
+	partition_areas=new Vector<IssmDouble>(npart);
+	vec_average=new Vector<IssmDouble>(npart);
 
 	/*loop on each element, and add contribution of the element to the partition (surface weighted average): */
Index: issm/trunk/src/c/modules/AverageOntoPartitionx/AverageOntoPartitionx.h
===================================================================
--- issm/trunk/src/c/modules/AverageOntoPartitionx/AverageOntoPartitionx.h	(revision 12709)
+++ issm/trunk/src/c/modules/AverageOntoPartitionx/AverageOntoPartitionx.h	(revision 13395)
@@ -6,5 +6,5 @@
 #define _AVERAGEONTOPARTITIONXX_H
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../Container/Container.h"
 
Index: issm/trunk/src/c/modules/BamgConvertMeshx/BamgConvertMeshx.cpp
===================================================================
--- issm/trunk/src/c/modules/BamgConvertMeshx/BamgConvertMeshx.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/BamgConvertMeshx/BamgConvertMeshx.cpp	(revision 13395)
@@ -7,5 +7,5 @@
 #include "../../include/include.h"
 #include "../../toolkits/toolkits.h"
-#include "../../objects/objects.h"
+#include "../../classes/bamg/bamgobjects.h"
 
 using namespace bamg;
Index: issm/trunk/src/c/modules/BamgConvertMeshx/BamgConvertMeshx.h
===================================================================
--- issm/trunk/src/c/modules/BamgConvertMeshx/BamgConvertMeshx.h	(revision 12709)
+++ issm/trunk/src/c/modules/BamgConvertMeshx/BamgConvertMeshx.h	(revision 13395)
@@ -6,5 +6,5 @@
 #define _BAMGCONVERTMESHX_H
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/trunk/src/c/modules/BamgTriangulatex/BamgTriangulatex.cpp
===================================================================
--- issm/trunk/src/c/modules/BamgTriangulatex/BamgTriangulatex.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/BamgTriangulatex/BamgTriangulatex.cpp	(revision 13395)
@@ -7,5 +7,5 @@
 #include "../../include/include.h"
 #include "../../toolkits/toolkits.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 using namespace bamg;
Index: issm/trunk/src/c/modules/BamgTriangulatex/BamgTriangulatex.h
===================================================================
--- issm/trunk/src/c/modules/BamgTriangulatex/BamgTriangulatex.h	(revision 12709)
+++ issm/trunk/src/c/modules/BamgTriangulatex/BamgTriangulatex.h	(revision 13395)
@@ -6,5 +6,5 @@
 #define _BAMGTRIANGULATEX_H
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
